--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")
local _, ns = ...
local oUF = ns.oUF
local addonName, addon = ...
local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}

local function CreateBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = 0, left = 0, bottom = 0, right = 0}})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,0)
end
local function FrameWrap(frame)
	local ButtonForeground = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		--ButtonForeground:SetAllPoints(frame)
		ButtonForeground:SetPoint("LEFT",frame,"LEFT",-2,0)
		ButtonForeground:SetSize(110,14)
		-- ButtonForeground:EnableMouse(true)
		-- ButtonForeground:SetMouseMotionEnabled(true)
		-- ButtonForeground:SetMouseClickEnabled(true)
		ButtonForeground:SetFrameLevel(0)
		ButtonForeground:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\PsychoBorder",
		edgeSize = 8,
		insets = {top = 4, left = 4, bottom = 4, right = 4}})
		ButtonForeground:SetBackdropColor(0,0,0,0)
		ButtonForeground:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
end
local function CastBarWrap(frame)
	local CastBarWrap = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		CastBarWrap:SetPoint("LEFT",frame,"LEFT",-2,0)
		CastBarWrap:SetSize(110,14)
		CastBarWrap:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\PsychoBorder",
		edgeSize = 8,
		insets = {top = 4, left = 4, bottom = 4, right = 4}})
		CastBarWrap:SetBackdropColor(InkedColors.r,InkedColors.g,InkedColors.b,0)
		CastBarWrap:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
end
local function AuraWrap(frame)
	local AuraWrap = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		AuraWrap:SetAllPoints(frame)
		--AuraWrap:SetPoint("CENTER",frame,"CENTER",0,0)
		AuraWrap:SetSize(30,30)
		AuraWrap:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\PsychoBorder",
		edgeSize = 16,
		insets = {top = 6, left = 6, bottom = 6, right = 6}})
		AuraWrap:SetBackdropColor(InkedColors.r,InkedColors.g,InkedColors.b,0)
		AuraWrap:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
end


oUF:RegisterStyle("Inked_Nameplates", function(frame, unit)
if Inked.db.profile.UseNameplates == false then return end

	-----------------
	--  Mouse Code --
	-----------------
	frame:SetScript('OnEnter', UnitFrame_OnEnter)
	frame:SetScript('OnLeave', UnitFrame_OnLeave)
	frame:EnableMouse(true)
	frame:SetMouseMotionEnabled(true)
	frame:SetMouseClickEnabled(true)

	frame:RegisterForClicks'AnyUp'
	
	frame:SetSize(105, 12)
    frame:SetPoint("CENTER", 0, 0)
	
	FrameWrap(frame)
	--CreateBackdrop(frame)
	
 
    if unit == "player" then
        -- your player-specific code here
    elseif unit == "boss1" then
        -- your boss1-specific code here
    elseif unit:match("nameplate") then
	

        -- health bar
        local health = CreateFrame("StatusBar", nil, frame, BackdropTemplateMixin and "BackdropTemplate")
        health:SetAllPoints()
        health:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.NamePlateStatusBar))
		health:GetStatusBarTexture():SetHorizTile(false)
		health:GetStatusBarTexture():SetVertTile(false)
        health.colorHealth = true
        health.colorTapping = true
		health.colorSmooth = true
		--health.frequentUpdates = true
        health.colorDisconnected = true
		health.colorReaction = true
        frame.Health = health
		frame.Health:SetFrameLevel(1)
				
		CreateBackdrop(health)		
		
        -- set size and points
        
		------------------
		--   Name Text --
		------------------
		local NameText = frame:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText:SetPoint("TOPLEFT", frame, 20,13) -- but anchor to the base element so it doesn't wiggle
		NameText:SetFont(LSM:Fetch("font", Inked.db.profile.NamePlatefont), 11, "OUTLINE")
		NameText:SetJustifyH("LEFT")
		NameText:SetWidth(400)	
		frame:Tag(NameText, "[name]")
	
		------------------
		--   Level Text --
		------------------
		local LevelText = frame:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		LevelText:SetPoint("TOPLEFT", frame, 0,13) -- but anchor to the base element so it doesn't wiggle
		LevelText:SetFont(LSM:Fetch("font", Inked.db.profile.NamePlatefont), 11, "OUTLINE")
		LevelText:SetJustifyH("LEFT")
		frame:Tag(LevelText, "[level]") 
		
		------------------
		--   Health Text --
		------------------
		local HealthText = frame:CreateFontString(nil, "OVERLAY", "TextStatusBarText")
		--HealthText:SetFrameLevel(12)		-- parent to last child to make sure it's on top
		HealthText:SetPoint("CENTER", frame, 0,0) -- but anchor to the base element so it doesn't wiggle
		HealthText:SetFont(LSM:Fetch("font", Inked.db.profile.NamePlatefont), 10, "OUTLINE")
		HealthText:SetJustifyH("LEFT")
		frame:Tag(HealthText, "[perhp]".." %")
		--------------
		-- Cast Bar --
		--------------
		local Castbar = CreateFrame("StatusBar", nil, frame, BackdropTemplateMixin and "BackdropTemplate")
		Castbar:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.NamePlateStatusBar))
		Castbar:SetStatusBarColor(0.25, 0, 0.85, 0.85)
		Castbar:SetSize(105, 12)
		Castbar:SetPoint('BOTTOMLEFT', frame, 0, -18)
		CastBarWrap(Castbar)
		CreateBackdrop(Castbar)
		
		--CreateBackdrop(Castbar)
		-- Add a spark
		local Spark = Castbar:CreateTexture(nil, "OVERLAY")
		Spark:SetSize(30, 10)
		Spark:SetBlendMode("ADD")

		-- Add a timer
		local Time = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
		Time:SetFont(LSM:Fetch("font", Inked.db.profile.NamePlatefont), 10, "OUTLINE")
		Time:SetTextColor(0.95, 0.95, 0.95)
		Time:SetPoint("RIGHT", Castbar, -5, 0)

		-- Add spell text
		local Text = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
		Text:SetFont(LSM:Fetch("font", Inked.db.profile.NamePlatefont), 10, "OUTLINE")
		Text:SetTextColor(0.95, 0.95, 0.95)
		Text:SetPoint("LEFT", Castbar, 5, 0)

		-- Add Shield
		local Shield = Castbar:CreateTexture(nil, "OVERLAY")
		Shield:SetSize(14, 14)
		Shield:SetPoint("CENTER", Castbar)

		local Icon = Castbar:CreateTexture(nil, 'OVERLAY')
		Icon:SetSize(14, 14)
		Icon:SetPoint('LEFT', Castbar, 'LEFT',-25,0)
		-- Add safezone
		local SafeZone = Castbar:CreateTexture(nil, "OVERLAY")

		-- Register it with oUF
		frame.Castbar = Castbar
		frame.Castbar.bg = Background
		frame.Castbar.Spark = Spark
		frame.Castbar.Time = Time
		frame.Castbar.Text = Text
		frame.Castbar.SafeZone = SafeZone
		frame.Castbar.Icon = Icon
			
		-----------
		-- Auras --
		-----------

		local Auras = CreateFrame("Frame", nil, frame, BackdropTemplateMixin and "BackdropTemplate")
		Auras:SetPoint("BOTTOMLEFT", frame, "TOPLEFT", 0,15)
		Auras:SetPoint("BOTTOMRIGHT", frame, "TOPRIGHT", 128, 15)
		Auras:SetHeight(20 + 4)
		Auras.disableMouse = false
		--AuraWrap(Auras)

		Auras.size = 20
		Auras.onlyShowPlayer = false
		Auras.gap = 2
		Auras.spacing = 2
		Auras.showStealableAuras = true
		Auras.disableCooldown = false
		Auras.num = 32

		Auras.PostCreateIcon = Aura_PostCreateIcon
		frame.Auras = Auras
		--AuraWrap(Aura_PostCreateIcon)
		---------------------------
		-- Floating Combat Frame --
		---------------------------

		local fcf = CreateFrame("Frame", nil, frame, BackdropTemplateMixin and "BackdropTemplate")
		fcf:SetSize(32, 32)
		fcf:SetPoint("CENTER",0,50)
		for i = 1, 6 do
			fcf[i] = fcf:CreateFontString("$parentFCFText" .. i, "OVERLAY")
		end
		
		fcf.font = "Interface\\Addons\\Inked\\Fonts\\Roboto.TTF"
		fcf.fontHeight = 24
		fcf.fontFlags = "OUTLINE"

		frame.FloatingCombatFeedback = fcf
		
		------------------------------
		--  Raid Target Indicator   --
		------------------------------
		
		local RTI = CreateFrame("Frame", nil, frame, BackdropTemplateMixin and "BackdropTemplate")
		local RaidTargetIndicator = frame:CreateTexture(nil, 'OVERLAY')
		RaidTargetIndicator:SetSize(24, 24)
		RaidTargetIndicator:SetPoint('RIGHT', frame,25,-6)
		frame.RaidTargetIndicator = RaidTargetIndicator

			
		--------------------
		--  Elite Units   --
		--------------------
		
		
		local EliteText = frame:CreateFontString(nil, "OVERLAY", "TextStatusBarText") 
		EliteText:SetWidth(50)
		EliteText:SetPoint("RIGHT", frame, 17,0) 
		EliteText:SetFont(LSM:Fetch("font", Inked.db.profile.NamePlatefont), 18, "OUTLINE")
		EliteText:SetJustifyH("RIGHT")--classification
		EliteText:SetTextColor(0.73,0.78,0.15,1)

		NameplateEliteIconFrame = frame:CreateTexture(nil, "BACKGROUND")
		NameplateEliteIconFrame:SetTexture("")
		NameplateEliteIconFrame:SetPoint("RIGHT", frame, 5,0)
		NameplateEliteIconFrame:SetSize(32, 16)
		frame:Tag(EliteText, "[shortclassification]") 
				

    end
end)
oUF:Factory(function(self)
--target = function(self)
	if Inked.db.profile.UseNameplates == false then return end
     self:SetActiveStyle("Inked_Nameplates")

   local cvars = {
    -- important, strongly recommend to set these to 1
    nameplateGlobalScale = 1,
	nameplateMinAlpha = 1,
	nameplateSelectedAlpha = 1,
    NamePlateHorizontalScale = 1,
    NamePlateVerticalScale = 1,
    -- optional, you may use any values
    nameplateLargerScale = 1,
    nameplateMaxScale = 1,
    nameplateMinScale = 1,
    nameplateSelectedScale = 0.95,
    nameplateSelfScale = 1,
	--nameplateOtherTopInset = 0.1,
	--nameplateOtherBottomInset  = 0.1,
	--nameplateResourceOnTarget = 0,
	--nameplateSelfTopInset =  0.1,
	--nameplateSelfBottomInset = 0.1,

}
 
oUF:SpawnNamePlates(nil, nil, cvars)
end)